'use strict';

var Pt = require('crypto');
var ze = require('fs');
var path = require('path');
var promises = require('fs/promises');
var Ai = require('tty');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var Pt__default = /*#__PURE__*/_interopDefault(Pt);
var ze__default = /*#__PURE__*/_interopDefault(ze);
var Ai__default = /*#__PURE__*/_interopDefault(Ai);

function Tr(){if(typeof self<"u")return self;if(typeof window<"u")return window;if(typeof global<"u")return global;if(typeof globalThis<"u")return globalThis;throw new Error("unable to locate global object")}function Q(){let e=Tr();return e._zeedGlobal==null&&(e._zeedGlobal={}),e._zeedGlobal}function Lr(e){return e===!0||e==="true"||e==="1"||typeof e=="number"&&e!==0?e="*":e===!1||e==="false"||e===0||e==="0"||e==null||e==="null"||e==="undefined"?e="":e=String(e),e}function Ar(){return Lr(typeof process<"u"?process.env.ZEED??process.env.DEBUG:typeof localStorage<"u"?localStorage.zeed??localStorage.debug:"*")}function j(e=Ar()){let t,n=[],r=[];if(!e)t=function(o){return !1};else if(e==="*")t=function(o){return !0};else {let o,i=e.split(/[\s,]+/),a=i.length;for(o=0;o<a;o++){if(!i[o])continue;let s=i[o].replace(/\*/g,".*?");s[0]==="-"?n.push(new RegExp(`^${s.substr(1)}$`)):r.push(new RegExp(`^${s}$`));}t=function(s){if(n.length===0&&r.length===0)return !0;let u,c;for(u=0,c=n.length;u<c;u++)if(n[u].test(s))return !1;for(u=0,c=r.length;u<c;u++)if(r[u].test(s))return !0;return !1};}return t.accept=r,t.reject=n,t.filter=e,t}function vr(){return typeof process<"u"?process.env.ZEED_LEVEL??process.env.LEVEL??process.env.DEBUG_LEVEL:typeof localStorage<"u"?localStorage.zeed_level??localStorage.level??localStorage.debug_level:void 0}function Ze(e){if(e===!1)return X;if(typeof e=="number")return e;if(typeof e=="string"){let t=$t[e.toLocaleLowerCase().trim()];if(t!=null)return t}return W}function z(e=vr()){let t=Ze(e);return n=>n>=t}function we(e={}){let{level:t=void 0,filter:n=void 0}=e,r=j(n),o=z(t);return i=>{if(!o(i.level)||!r(i.name))return;let a=i.name?`[${i.name}]`:"";switch(i.level){case O:console.info(`I|*   ${a}`,...i.messages);break;case B:console.warn(`W|**  ${a}`,...i.messages);break;case $:console.error(`E|*** ${a}`,...i.messages);break;default:console.debug(`D|    ${a}`,...i.messages);break}}}var W=-1,J=0,O=1,B=2,$=3,Te=4,X=9007199254740991,$t={"*":W,a:W,all:W,d:J,dbg:J,debug:J,i:O,inf:O,info:O,w:B,warn:B,warning:B,e:$,err:$,error:$,fatal:Te,off:X,"-":X};function Ot(e=""){let t=[we()],n=u=>!0,r=!1,o=a,i=!1;function a(u="",c){let p=Ze(c??W);function l(g,m){return p<=g?m:()=>{}}let f=l(J,(...g)=>{d({name:u,messages:g,level:J});});f.label=u,f.extend=function(g){return o(u?`${u}:${g}`:g)};let d=g=>{if(n(u))for(let m of t)m&&m(g);};return f.debug=l(J,(...g)=>{d({name:u,messages:g,level:J});}),f.info=l(O,(...g)=>{d({name:u,messages:g,level:O});}),f.warn=l(B,(...g)=>{d({name:u,messages:g,level:B});}),f.error=l($,(...g)=>{d({name:u,messages:g,level:$});}),f.fatal=l(Te,(...g)=>{throw d({name:u,messages:g,level:Te}),new Error(`${g.map(String).join(" ")}`)}),f.assert=l(Te,(g,...m)=>{(g==null||typeof g=="number"&&isNaN(g)||!g)&&f.fatal(...m);}),f}function s(u="",c){let p=o(u,c);return i&&p.debug(`+++ init of logger "${u}" on level "${p.level}".`),p}return s.registerHandler=function(u){t.push(u);},s.setFilter=function(u){n=j(u);},s.setLock=(u=!0)=>r=u,s.setDebug=(u=!0)=>i=u,s.setHandlers=function(u=[]){o!==a&&(o=a),!r&&(t=[...u].filter(c=>typeof c=="function"));},s.level=W,s.setLogLevel=function(u=W){r||(s.level=u);},s.setFactory=function(u){r||(o=u);},s}var N;function Ke(e){let t=Ot();return e?e(t):t.setHandlers([we()]),t}function Ye(e){if(N==null)try{let t=Q();t!=null?t?.logger==null?(N=Ke(e),t.logger=N):N=t.logger:N=Ke(e);}catch{N=Ke(e);}return N}function _t(){if(N!=null)return N;try{let e=Q();if(e?.logger!=null)return e.logger}catch{}}function k(e,t){return Ye()(e,t)}function Ur(...e){throw _t()?.("assert")?.fatal(...e),new Error(`${e.map(String).join(" ")}`)}function Er(e,...t){(e==null||typeof e=="number"&&isNaN(e)||!e)&&Ur(...t);}function jt(e,...t){Er(e,...t);}var Nt=(e,t)=>t instanceof Object&&!Array.isArray(t)?Object.keys(t).sort().reduce((n,r)=>(n[r]=t[r],n),{}):t;function Hi(e,t=void 0){return JSON.stringify(e,Nt,t)}function Dr(e,t){let n=[],r=[];return t==null&&(t=function(o,i){return n[0]===i?"[Circular ~]":`[Circular ~.${r.slice(0,n.indexOf(i)).join(".")}]`}),function(o,i){if(n.length>0){let a=n.indexOf(this);~a?n.splice(a+1):n.push(this),~a?r.splice(a,1/0,o):r.push(o),~n.indexOf(i)&&(i=t?.call(this,o,i));}else n.push(i);i=Nt(o,i);try{return e==null?i:e.call(this,o,i)}catch{}return String(i)}}function I(e,t,n,r){return JSON.stringify(e,Dr(t,r),n)}var Gi=I;function Sr(e){let t=unescape(encodeURIComponent(e)),n=t.length,r=new Uint8Array(n);for(let o=0;o<n;o++)r[o]=t.codePointAt(o)||0;return r}function Pr(e){let t=e.length,n="",r=0;for(;t>0;){let o=t<1e4?t:1e4,i=e.subarray(r,r+o);r+=o,n+=String.fromCodePoint.apply(null,i),t-=o;}return decodeURIComponent(escape(n))}var Le;function Vt(e){if(Le==null&&(Le=Sr,typeof TextEncoder<"u")){let t=new TextEncoder;Le=n=>t.encode(n);}return Le(e.normalize("NFC"))}var Ae;function Ht(e){if(Ae==null&&(Ae=Pr,typeof TextDecoder<"u")){let t=new TextDecoder("utf-8",{ignoreBOM:!0});Ae=n=>t.decode(n);}return Ae(e).normalize("NFC")}function E(e){return e instanceof ArrayBuffer?new Uint8Array(e):typeof e=="string"?Vt(e):e.length?new Uint8Array(e):e}function qi(...e){let t=0,n=e.flat(1).map(i=>{let a=E(i);return t+=a.length,a}),r=new Uint8Array(t),o=0;for(let i of n)r.set(i,o),o+=i.length;return r}function Gt(e){if(typeof Buffer<"u")return Buffer.from(E(e)).toString("hex");let t="0123456789abcdef",n="";for(let r of [...E(e)])n+=t[r>>4]+t[r&15];return n}function zt(e){return Uint8Array.from(e.match(/.{1,2}/g).map(t=>parseInt(t,16)))}function le(e,t=!1){let n=E(e),r="";if(typeof Buffer<"u")r=Buffer.from(n).toString("base64");else {let o="";for(let i=0;i<n.byteLength;i++)o+=String.fromCharCode(n[i]);r=btoa(o);}return t?r.replaceAll("=",""):r}function Ji(e){let t=E(e);if(typeof Buffer<"u")return Buffer.from(t).toString("base64url").replaceAll("=","");let n="";for(let r=0;r<t.byteLength;r++)n+=String.fromCharCode(t[r]);return btoa(n).replaceAll("+","-").replaceAll("/","_").replaceAll("=","")}function ve(e){if(e=e.replaceAll("-","+").replaceAll("_","/"),typeof Buffer<"u"){let r=Buffer.from(e,"base64");return new Uint8Array(r.buffer,r.byteOffset,r.byteLength)}let t=atob(e),n=new Uint8Array(t.length);for(let r=0;r<t.length;r++)n[r]=t.charCodeAt(r);return n}function Zi(e){return Ht(ve(e))}function Wt(e,t){if(e.byteLength!==t.byteLength)return !1;let n=E(e),r=E(t);for(let o=0;o<n.length;o++)if(n[o]!==r[o])return !1;return !0}function Qe(e){return Vt(I(e))}function Xe(e){return JSON.parse(Ht(e))}function qt(e,t){if(typeof e!="string")if(e instanceof ArrayBuffer&&e.byteLength!==void 0)e=String.fromCharCode.apply(String,[].slice.call(new Uint8Array(e)));else if(Array.isArray(e))e=String.fromCharCode.apply(String,e);else if(e.constructor===Uint8Array)e=String.fromCharCode.apply(String,[].slice.call(e));else return !1;t=t||16;let n=[],r="0123456789ABCDEF";for(let o=0;o<e.length;o+=t){let i=e.slice(o,Math.min(o+t,e.length)),a=`0000${o.toString(16)}`.slice(-4),s=i.split("").map(c=>{let p=c.charCodeAt(0);return ` ${r[(240&p)>>4]}${r[15&p]}`}).join("");s+="   ".repeat(t-i.length);let u=i.replace(/[\x00-\x1F\x20\x7F-\xA0\xAD]/g,".");u+=" ".repeat(t-i.length),n.push(`${a} ${s}  ${u}`);}return n.join(`
`)}var ee;function Zt(){return ee===void 0&&(ee=(typeof TextDecoder>"u"?null:new TextDecoder("utf-8",{fatal:!0,ignoreBOM:!0}))??null,ee&&ee.decode(new Uint8Array).length===1&&(ee=null)),ee}var Yt="Unexpected end of array",Qt="Integer out of Range",et=class{constructor(t){this.arr=t,this.pos=0;}};function Se(e){return new et(e)}function tt(e,t){let n=de(e.arr.buffer,e.pos+e.arr.byteOffset,t);return e.pos+=t,n}function te(e){let t=0,n=1,r=e.arr.length;for(;e.pos<r;){let o=e.arr[e.pos++];if(t=t+(o&127)*n,n*=128,o<128)return t;if(t>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function Pe(e){return tt(e,te(e))}function pe(e){return e.arr[e.pos++]}function Xt(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8);return e.pos+=2,t}function en(e){let t=e.arr[e.pos]+(e.arr[e.pos+1]<<8)+(e.arr[e.pos+2]<<16)+(e.arr[e.pos+3]<<24)>>>0;return e.pos+=4,t}function nt(e){let t=e.arr[e.pos++],n=t&63,r=64,o=(t&64)>0?-1:1;if(!(t&128))return o*n;let i=e.arr.length;for(;e.pos<i;){if(t=e.arr[e.pos++],n=n+(t&127)*r,r*=128,t<128)return o*n;if(n>Number.MAX_SAFE_INTEGER)throw new Error(Qt)}throw new Error(Yt)}function kr(e){let t=te(e);if(t===0)return "";{let n=String.fromCodePoint(pe(e));if(--t<100)for(;t--;)n+=String.fromCodePoint(pe(e));else for(;t>0;){let r=t<1e4?t:1e4,o=e.arr.subarray(e.pos,e.pos+r);e.pos+=r,n+=String.fromCodePoint.apply(null,o),t-=r;}return decodeURIComponent(escape(n))}}function De(e){let t=Zt();return t?t.decode(Pe(e)):kr(e)}function rt(e,t){let n=new DataView(e.arr.buffer,e.arr.byteOffset+e.pos,t);return e.pos+=t,n}function ot(e){return rt(e,4).getFloat32(0,!1)}function Ir(e){return rt(e,8).getFloat64(0,!1)}function Mr(e){return rt(e,8).getBigInt64(0,!1)}var Cr=[e=>{},e=>null,nt,ot,Ir,Mr,e=>!1,e=>!0,De,e=>{let t=te(e),n={};for(let r=0;r<t;r++){let o=De(e);n[o]=ne(e);}return n},e=>{let t=te(e),n=[];for(let r=0;r<t;r++)n.push(ne(e));return n},Pe];function ne(e){return Cr[127-pe(e)](e)}function de(e,t,n){return new Uint8Array(e,t,n)}var it=class{constructor(){this.cpos=0,this.cbuf=new Uint8Array(100),this.bufs=[];}};function ke(){return new it}function st(e){let t=e.cpos;for(let n=0;n<e.bufs.length;n++)t+=e.bufs[n].length;return t}function Ie(e){let t=new Uint8Array(st(e)),n=0;for(let r=0;r<e.bufs.length;r++){let o=e.bufs[r];t.set(o,n),n+=o.length;}return t.set(de(e.cbuf.buffer,0,e.cpos),n),t}function Br(e,t){let n=e.cbuf.length;n-e.cpos<t&&(e.bufs.push(de(e.cbuf.buffer,0,e.cpos)),e.cbuf=new Uint8Array(Math.max(n,t)*2),e.cpos=0);}function S(e,t){let n=e.cbuf.length;e.cpos===n&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(n*2),e.cpos=0),e.cbuf[e.cpos++]=t;}var rn=S;function on(e,t){S(e,t&255),S(e,t>>>8&255);}function sn(e,t){for(let n=0;n<4;n++)S(e,t&255),t>>>=8;}function Z(e,t){for(;t>127;)S(e,128|127&t),t=Math.floor(t/128);S(e,127&t);}function $r(e){return e!==0?e<0:1/e<0}function at(e,t){let n=$r(t);for(n&&(t=-t),S(e,(t>63?128:0)|(n?64:0)|63&t),t=Math.floor(t/64);t>0;)S(e,(t>127?128:0)|127&t),t=Math.floor(t/128);}function Me(e,t){let n=e.cbuf.length,r=e.cpos,o=Math.min(n-r,t.length),i=t.length-o;e.cbuf.set(t.subarray(0,o),r),e.cpos+=o,i>0&&(e.bufs.push(e.cbuf),e.cbuf=new Uint8Array(Math.max(n*2,i)),e.cbuf.set(t.subarray(o)),e.cpos=i);}function Ce(e,t){Z(e,t.byteLength),Me(e,t);}function _r(e,t){let n=unescape(encodeURIComponent(t)),r=n.length;Z(e,r);for(let o=0;o<r;o++)S(e,n.codePointAt(o));}function Fe(e,t){return _r(e,t)}function ut(e,t){Br(e,t);let n=new DataView(e.cbuf.buffer,e.cpos,t);return e.cpos+=t,n}function ct(e,t){return ut(e,4).setFloat32(0,t,!1)}function jr(e,t){return ut(e,8).setFloat64(0,t,!1)}function Nr(e,t){return ut(e,8).setBigInt64(0,t,!1)}var Re;function Vr(e){return Re==null&&(Re=new DataView(new ArrayBuffer(4))),Re.setFloat32(0,e),Re.getFloat32(0)===e}function oe(e,t){switch(typeof t){case"string":S(e,119),Fe(e,t);break;case"number":Number.isInteger(t)&&Math.abs(t)<=2147483647?(S(e,125),at(e,t)):Vr(t)?(S(e,124),ct(e,t)):(S(e,123),jr(e,t));break;case"bigint":S(e,122),Nr(e,t);break;case"object":if(t===null)S(e,126);else if(Array.isArray(t)){S(e,117),Z(e,t.length);for(let n=0;n<t.length;n++)oe(e,t[n]);}else if(t instanceof Uint8Array)S(e,116),Ce(e,t);else {S(e,118);let n=Object.keys(t);Z(e,n.length);for(let r=0;r<n.length;r++){let o=n[r];Fe(e,o),oe(e,t[o]);}}break;case"boolean":S(e,t?120:121);break;default:S(e,127);}}var an=class{async encode(t){let n=ke();return oe(n,t),Ie(n)}async decode(t){return ne(Se(E(t)))}};function ps(e){let t=ke();return oe(t,e),Ie(t)}function ds(e){return ne(Se(E(e)))}function gs(e){let t=ke();return e!=null&&Me(t,E(e)),{writeBytes:(n,r)=>{let o=E(n);jt(!(r!=null&&o.length!==r),`Expected ${r} bytes, got ${o.length}`),Me(t,o);},writeBytesVar:n=>Ce(t,E(n)),writeUintVar:n=>Z(t,n),writeUint8:n=>rn(t,n),writeUint16:n=>on(t,n),writeUint32:n=>sn(t,n),writeIntVar:n=>at(t,n),writeFloat:n=>ct(t,n),writeStringVar:n=>Fe(t,n),write:n=>oe(t,n),getUint8Array:()=>Ie(t),getLength:()=>st(t)}}function ms(e){let t=Se(E(e));return {readBytes:n=>tt(t,n),readBytesVar:()=>Pe(t),readUintVar:()=>te(t),readUint8:()=>pe(t),readUint16:()=>Xt(t),readUint32:()=>en(t),readIntVar:()=>nt(t),readFloat:()=>ot(t),readStringVar:()=>De(t),read:()=>ne(t),getOffset:()=>t.pos||0}}function ys(e=0){return {setBit:(t,n=!0)=>n?e|=1<<t:e&=~(1<<t),unsetBit:t=>e&=1<<t,toggleBit:t=>e^=1<<t,getBit:t=>(e&1<<t)!==0,getValue:()=>e}}async function Hr(e){return await e.arrayBuffer()}async function hs(e){let t=await Hr(e);if(t!=null)return E(t)}function ie(e=16){let t=new Uint8Array(e);if(typeof crypto<"u"&&crypto.getRandomValues)crypto.getRandomValues(t);else for(let n=0;n<e;n++)t[n]=Math.floor(Math.random()*256);return t}var cn="SHA-256",lt="AES-GCM",un="PBKDF2",Gr=1e5;async function ws(e,t=cn){return E(await crypto.subtle.digest(t,E(e)))}async function Ts(e,t={}){let n=E(e),r=await crypto.subtle.importKey("raw",n,un,!1,["deriveKey"]);return await crypto.subtle.deriveKey({name:un,salt:t.salt?E(t.salt):new Uint8Array(0),iterations:t.iterations??Gr,hash:cn},r,{name:lt,length:256},!0,["encrypt","decrypt"])}function ln(){return new Uint8Array([1,1])}async function fn(e,t){let n=ln(),r=ie(12),o=await crypto.subtle.encrypt({name:lt,iv:r},t,e),i=new Uint8Array(o),a=n.length+r.length+i.length,s=new Uint8Array(a),u=0;return s.set(n,u),u+=n.length,s.set(r,u),u+=r.length,s.set(i,u),s}async function pn(e,t){let n=e.subarray(0,2);if(!Wt(n,ln()))return Promise.reject(new Error(`Unknown magic ${n}`));let r=e.subarray(2,2+12),o=e.subarray(2+12,e.length),i=await crypto.subtle.decrypt({name:lt,iv:r},t,o);return new Uint8Array(i)}function zr(){return crypto.getRandomValues(new Uint32Array(1))[0]/4294967295}function R(){return typeof crypto<"u"?zr():Math.random()}function As(e=.25){return R()<e}function vs(e=100,t=0){return t+Math.floor(R()*(e-t))}function Us(e=100,t=0){return t+R()*(e-t)}function Es(e,t,n){return Math.max(e,Math.min(n,t))}function Wr(e){return e.reduce((t,n)=>t+n,0)}function Ds(e){return Wr(e)/e.length}function Ss(e){return !/^1?$|^(11+?)\1+$/.test("1".repeat(e))}function Ps(e){for(let t=2;t<e;t++)if(e%t===0)return !1;return e>1}var ft=6;function Rs(e=0,t=1,n){ft=((n??ft)*9301+49297)%233280;let r=ft/233280;return t+r*(e-t)}function qr(e=""){let[t="",n="asc"]=e.split(" ");return n=n.toLowerCase(),{field:t,orderby:n,asc:n!=="desc",desc:n==="desc"}}function ks(e,t=!0){return `${e} ${t?"asc":"desc"}`}function pt(e,t,n=!0){let r=e||0,o=t||0;return r>o?n?1:-1:r<o?n?-1:1:0}function Is(e,...t){if(t.length>0){let n=t.map(qr),r=Array.from(e);return r.sort((o,i)=>{for(let{field:a,asc:s}of n){let u=pt(o[a],i[a],s);if(u!==0)return u}return 0}),r}return e}function dt(e){return e.filter((t,n)=>e.indexOf(t)===n)}function Jr(e,t){return dt(e.filter(n=>!t.includes(n)))}function Zr(...e){return dt(e.reduce((t=[],n)=>t.concat(n),[]))}function se(...e){return e.flat(1/0)}function Kr(e,t){return dt(e).filter(n=>t.includes(n))}function $s(e,t){return Jr(Zr(e,t),Kr(e,t))}function dn(e,t){if(e&&Array.isArray(e)){let n;for(;(n=e.indexOf(t))!==-1;)e.splice(n,1);return e}return []}function Os(e,t){return e.includes(t)||e.push(t),e}function gt(e,t){return e.splice(0,e.length,...e.filter(t)),e}function _s(e,t){let n=e.findIndex(r=>r===t);return n>=0?e.splice(n,1):e.push(t),e}function js(e){return e.splice(0,e.length),e}function Yr(e,t=pt){return Array.from(e).sort(t)}function Ns(e){return Yr(e,(t,n)=>t-n)}function Qr(e,t){return e.length===t.length&&e.every((n,r)=>n===t[r])}function gn(e){return e.sort(()=>R()>.5?1:-1),e}function Vs(e){return gn(Array.from(e))}function Hs(e){for(;e.length>1;){let t=Array.from(e);if(gn(t),!Qr(e,t))return t}return e}function Gs(e){return e[Math.floor(R()*e.length)]}function zs(...e){return se(e).reduce((t,n)=>t!=null?n>t?n:t:n,void 0)}function Ws(...e){return se(e).reduce((t,n)=>t!=null?n<t?n:t:n,void 0)}function qs(...e){return se(e).reduce((t,n)=>t+n,0)}function Js(...e){let t=se(e);return t.reduce((n,r)=>n+r,0)/t.length}function Zs(e,t){let n=[],r=0,o=e.length;for(;r<o;)n.push(e.slice(r,r+=t));return n}function Ks(e=0,t){if(e<=0)return [];let n=new Array(e);for(let r=0;r<e;r++)n[r]=t instanceof Function?t(r):t;return n}var Xr={2:"01",8:"01234567",11:"0123456789a",16:"0123456789abcdef",32:"0123456789abcdefghjkmnpqrtuvwxyz","32-crockford":"0123456789ABCDEFGHJKMNPQRSTVWXYZ","32-geohash":"0123456789bcdefghjkmnpqrstuvwxyz","32-agnoster":"0123456789abcdefghjkmnpqrtuvwxyz","32-rfc":"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567","32-hex":"0123456789ABCDEFGHIJKLMNOPQRSTUV","32-zbase":"ybndrfg8ejkmcpqxot1uwisza345h769",36:"0123456789abcdefghijklmnopqrstuvwxyz",58:"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz",62:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz",64:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/","64-url":"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_",66:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.!~",85:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!#$%&()*+-;<=>?@^_`{|}~"};function eo(e){let t=Xr[String(e)];if(!t)if(typeof e=="string")t=e;else throw new Error(`Unknown base ${e}`);if(t.length>=255)throw new TypeError("Alphabet too long");let n=new Uint8Array(256);for(let c=0;c<n.length;c++)n[c]=255;for(let c=0;c<t.length;c++){let p=t.charAt(c),l=p.charCodeAt(0);if(n[l]!==255)throw new TypeError(`${p} is ambiguous`);n[l]=c;}let r=t.length,o=t.charAt(0),i=Math.log(r)/Math.log(256),a=Math.log(256)/Math.log(r);function s(c,p=-1){let l=E(c);if(l.byteLength===0)return "";let f=0,d=0,g=l.byteLength;for(;d!==g&&l[d]===0;)d++;let m=(g-d)*a+1>>>0,b=new Uint8Array(m);for(;d!==g;){let v=l[d],D=0;for(let h=m-1;(v!==0||D<f)&&h!==-1;h--,D++)v+=256*b[h]>>>0,b[h]=v%r>>>0,v=v/r>>>0;if(v!==0)throw new Error("Non-zero carry");f=D,d++;}let y=m-f;for(;y!==m&&b[y]===0;)y++;let T="";for(;y<m;++y)T+=t.charAt(b[y]);return p>0?T.padStart(p,o):T}function u(c,p=-1){if(typeof c!="string")throw new TypeError("Expected String");if(c.length===0)return new Uint8Array;c=c.replace(/\s+/gi,"");let l=0,f=0;for(;c[l]===o;)l++;let d=(c.length-l)*i+1>>>0,g=new Uint8Array(d);for(;c[l];){let b=n[c.charCodeAt(l)];if(b===255)throw new Error(`Unsupported character "${c[l]}"`);let y=0;for(let T=d-1;(b!==0||y<f)&&T!==-1;T--,y++)b+=r*g[T]>>>0,g[T]=b%256>>>0,b=b/256>>>0;if(b!==0)throw new Error("Non-zero carry");f=y,l++;}let m=d-f;for(;m!==d&&g[m]===0;)m++;return p>0?new Uint8Array([...new Uint8Array(p-g.length+m),...g.slice(m)]):g.slice(m)}return {encode:s,decode:u}}var Be;function q(e){Be==null&&(Be=new Map);function t(){let o=Be.get(e);return o==null&&(o=eo(e),Be.set(e,o)),o}function n(o,i=-1){return t().encode(o,i)}function r(o,i=-1){return t().decode(o,i)}return {encode:n,decode:r}}function mt(e,t=-1){return q(32).encode(e,t)}function mn(e,t=-1){return q(32).decode(e.toLocaleLowerCase().replaceAll("l","1").replaceAll("s","5").replaceAll("o","0").replaceAll("i","1"),t)}function Xs(e,t=-1){return q(16).encode(e,t)}function ea(e,t=-1){return q(16).decode(e,t)}function ta(e,t=-1){return q(58).encode(e,t)}function na(e,t=-1){return q(58).decode(e,t)}function yt(e,t=-1){return q(62).encode(e,t)}function yn(e,t=-1){return q(62).decode(e,t)}function ra(e,t){return Math.ceil(e*(Math.log(256)/Math.log(t)))}var hn=e=>(e.length>0&&(/^[A-Z0-9_\-\ ]*$/g.test(e)&&(e=e.toLowerCase()),e=e.replace(/^[-_\ ]+/gi,"").replace(/[-_\ ]+$/gi,"").replace(/[-_\ ]+([a-z0-9])/gi,(t,n)=>n.toUpperCase()),e=e[0].toLowerCase()+e.substring(1)),e);function to(e){return e.charAt(0).toUpperCase()+e.toLowerCase().slice(1)}function ia(e){return e.replace(/\w\S*/g,to)}function sa(e,t="-"){return t=typeof t>"u"?"_":t,e.replace(/([a-z\d])([A-Z])/g,`$1${t}$2`).replace(/([A-Z]+)([A-Z][a-z\d]+)/g,`$1${t}$2`).toLowerCase()}var xn=["1","true","yes","y","on"];function ca(e,t=!1){return e==null||typeof e!="string"?t:xn.includes(String(e).trim().toLowerCase())}function la(e,t=0){return e==null||typeof e!="string"?t:parseInt(e.trim(),10)??t}function fa(e,t=0){return e==null||typeof e!="string"?t:parseFloat(e.trim())??t}function ae(e,t=!1){return e==null?t:typeof e=="boolean"?e:typeof e=="number"?e!==0:xn.includes(String(e).trim().toLowerCase())}function no(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseInt(String(e).trim(),10)??t}function ro(e,t=0){return e==null?t:typeof e=="boolean"?e?1:0:typeof e=="number"?Math.floor(e):parseFloat(String(e).trim())??t}function ht(e,t=""){return e==null?t:String(e)??t}var pa=ro,da=no,ga=ht,ma=ae;function oo(e,t={}){let{trace:n=!0,pretty:r=!0}=t;return e.map(o=>{if(o&&typeof o=="object"){if(r&&(o instanceof Uint8Array||o instanceof ArrayBuffer))return `
${qt(o)}
`;if(o instanceof Error)return n?`${o.name||"Error"}: ${o.message}
${o.stack}`:`${o.name||"Error"}: ${o.message}`;try{return r?JSON.stringify(o,null,2):JSON.stringify(o)}catch{}}return String(o)})}function $e(e,t={}){return oo(e,t).join(" ")}function ya(e){try{return decodeURIComponent(escape(e))}catch{}return e}function ba(e){if(e.startsWith("data:"))return ve(e.split(",",2)[1])}function wa(e){if(e.startsWith("data:"))return e.slice(5).split(",",2)[0]}function Ta(e){if(e.startsWith("data:")){let[t,n]=e.slice(5).split(",",2);return new Blob([ve(n)],{type:t})}}async function La(e){let t=await e.arrayBuffer();if(t)return `data:${e.type},${le(t)}`}function Aa(e,t="application/octet-stream"){return `data:${t},${le(e)}`}var bn=864e5;function bt(e){return Math.floor(e/1e4)}function wn(e){return Math.floor(e/100%100)}function io(e){return Math.floor(e%100)}function Ua(e){return [bt(e),wn(e),io(e)]}function Tn(e,t=!1){return t?new Date(`${ao(e)}T00:00:00.000Z`):new Date(e/1e4,e/100%100-1,e%100)}function Ln(){return _e(new Date)}function Ea(e,t=!1){if(typeof e=="number")return e<100?void 0:e;if(typeof e=="string")return An(e);if(Array.isArray(e)&&e.length===3){let[n,r,o]=e;return wt(n,r,o)}else if(e instanceof Date)return _e(e,t)}function Da(e){return Tn(e,!0)}function _e(e,t=!1){return t?An(e.toISOString()):e.getFullYear()*1e4+(e.getMonth()+1)*100+e.getDate()}function Sa(e){return _e(e,!0)}function xt(e,t=!0){return Tn(e,t).getTime()}function so(e,t=!0){return _e(new Date(e),t)}function ao(e,t="-"){let n=String(e);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}function wt(e,t=1,n=1){if(!(t<1||t>12||n<1||n>31))return e*1e4+t*100+n}function An(e){let t=String(e).replace(/[^0-9]/g,"").slice(0,8);if(t.length===8)return +t}function Pa(e,t=0){let n=bt(e),r=wn(e);return t!==0&&(r+=t,n+=Math.floor((r-1)/12),r=Math.floor((r-1)%12)+1,r===0&&(r=12)),wt(n,r,1)}function Ra(e,t=0){let n=bt(e);return wt(n+t,1,1)}function Oe(e,t){return so(xt(e)+t*864e5)}function Fa(e,t){return Math.round((xt(t)-xt(e))/864e5)}function ka(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)n.push(e),e=Oe(e,1);return n}function*Ia(e,t){let n=[];for(t==null&&(t=Ln()),e<0&&(e=Oe(t,e+1));e<=t;)yield e,e=Oe(e,1);return n}function vn(){let e,t;return [new Promise((r,o)=>{e=r,t=o;}),e,t]}async function Ca(e){return new Promise(t=>setTimeout(t,e))}async function Ba(){return new Promise(e=>setTimeout(e,0))}async function $a(e,t,n="timeoutReached"){return new Promise(async(r,o)=>{let i=!1,a=setTimeout(()=>{i=!0,r(n);},t);try{let s=await e;clearTimeout(a),i||r(s);}catch(s){clearTimeout(a),i||o(s);}})}function Oa(e){return e==="timeoutReached"||e?.name==="Timeout reached"}async function Un(e,t){return t<=0?await e:new Promise(async(n,r)=>{let o=!1,i=setTimeout(()=>{o=!0,r(new Error("Timeout reached"));},t);try{let a=await e;clearTimeout(i),o||n(a);}catch(a){clearTimeout(i),o||r(a);}})}function _a(e,t,n=1e3){return new Promise((r,o)=>{let i=u=>{s&&(clearTimeout(s),a(),r(u));},a=()=>{s=null,e.off?e.off(t,i):e.removeEventListener&&e.removeEventListener(t,i);},s=setTimeout(()=>{a(),o(new Error("Did not response in time"));},n);e.on?e.on(t,i):e.addEventListener&&e.addEventListener(t,i);})}function M(e){return !!(e&&(e instanceof Promise||typeof e.then=="function"))}function V(e){return Promise.resolve(e)}var A=class{get value(){return this.days}constructor(t){if(typeof t=="number"){this.days=t;return}if(t!=null&&(t=A.from(t)?.days),t==null){let n=new Date;this.days=n.getFullYear()*1e4+(n.getMonth()+1)*100+n.getDate();}else this.days=t;}static fromNumber(t){return new A(t)}static fromString(t){return A.from(+t.replace(/[^0-9]/g,"").slice(0,8))}static fromDate(t,n=!1){return n?A.fromString(t.toISOString().substr(0,10)):A.from(t.getFullYear()*1e4+(t.getMonth()+1)*100+t.getDate())}static fromDateGMT(t){return A.fromDate(t,!0)}static from(t,n=!1){if(typeof t=="number")return t<100?void 0:new A(t);if(typeof t=="string")return A.fromString(t);if(Array.isArray(t)&&t.length===3){let[r,o=1,i=1]=t;return o<1||o>12||i<1||i>31?void 0:new A(r*1e4+o*100+i)}else {if(t instanceof Date)return A.fromDate(t,n);if(t instanceof A)return t}}toNumber(){return this.days}toJson(){return this.days}toString(t="-"){let n=String(this.days);return n.slice(0,4)+t+n.slice(4,6)+t+n.slice(6,8)}toDate(t=!1){return t?new Date(`${this.toString()}T00:00:00.000Z`):new Date(this.days/1e4,this.days/100%100-1,this.days%100)}toDateGMT(){return this.toDate(!0)}get year(){return Math.floor(this.days/1e4)}get month(){return Math.floor(this.days/100%100)}get day(){return Math.floor(this.days%100)}dayOffset(t){return A.fromDateGMT(new Date(this.toDateGMT().getTime()+t*864e5))}monthStart(){return A.from([this.year,this.month,1])}yearStart(){return A.from([this.year,1,1])}monthOffset(t){let n=this.month+t,r=Math.floor((n-1)%12)+1;r===0&&(r=12);let o=Math.floor((n-1)/12);return A.from([this.year+o,r,this.day])}daysUntil(t){return Math.round((new A(t)?.toDateGMT().getTime()-this.toDateGMT().getTime())/864e5)}yesterday(){return this.dayOffset(-1)}tomorrow(){return this.dayOffset(1)}};async function Va(e,t,n){let r=A.from(e),o=A.from(t);for(;r&&o&&r?.days<=o?.days;){let i=n(r);M(i)&&await i,r=r.dayOffset(1);}}function Ha(){return new A}function Ga(e){return new A(e)}function za(e){return A.fromDate(new Date(e)).days}function uo(e,t=2){return +(+e).toFixed(t)}function qa(e,t=2){return +(+e/10**t).toFixed(t)}function Ja(e,t=2){return Math.round(+e*10**t)}function Za(e,t=2){return t*(uo(e,t)%1)}function H(e){return e!=null&&typeof e=="object"}function Tt(e){return Object(e)!==e}function G(e){return Array.isArray(e)}function je(e){return H(e)&&!G(e)}function Ya(e){return e?.constructor===Object}function En(e){return typeof e=="string"}function Dn(e){return typeof e=="number"&&!isNaN(e)}function Qa(e){return Dn(e)&&Number.isInteger(e)}function Xa(e){return Dn(e)&&Number.isSafeInteger(e)}function Sn(e){return typeof e=="boolean"}function eu(e){return e==null}function tu(e){return e==null}function nu(e){return H(e)&&e.constructor.name==="Uint8Array"}function Pn(e){return e!=null}function ru(e){return e!=null&&e!==!1&&e!==!0}function co(e,t,n=new WeakSet){if(e===t)return !0;if(n.has(t)||(Tt(t)||n.add(t),!(e instanceof Object)||!(t instanceof Object))||e.constructor!==t.constructor||e.length!==t.length)return !1;for(let r in e){if(!e.hasOwnProperty(r))continue;if(!t.hasOwnProperty(r))return !1;let o=e[r],i=t[r];if(!co(o,i,n))return !1}for(let r in t)if(t.hasOwnProperty(r)&&!e.hasOwnProperty(r))return !1;return !0}function lo(e,t=new WeakSet){if(t.has(e))return "[Circular ~]";if(Tt(e)||t.add(e),je(e)){for(let n in e)if(e.hasOwnProperty(n)){if(e[n]===void 0){delete e[n];continue}lo(e[n],t);}}else if(G(e))for(let n=e.length-1;n>=0;n--)e[n]===void 0&&e.splice(n,1);return e}function Ne(e,...t){for(let n of t)H(e)||(e={}),!(n==null||!H(n))&&Object.keys(n).forEach(r=>{let o=e[r],i=n[r];Array.isArray(o)&&Array.isArray(i)?e[r]=o.concat(i):H(o)&&H(i)?e[r]=Ne(Object.assign({},o),i):e[r]=i;});return e}function fo(e,t,n={cyclesFix:!0},r=[]){let o=[],i=Array.isArray(e);for(let s in e){let u=e[s],c=i?+s:s;if(!(s in t)){o.push({type:"del",path:[c]});continue}let p=t[s],l=typeof u=="object"&&typeof p=="object";if(u&&p&&l&&!["Date","RegExp","String","Number"].includes(Object.getPrototypeOf(u).constructor.name)&&(!n.cyclesFix||!r.includes(u))){let f=fo(u,p,n,n.cyclesFix?r.concat([u]):[]);o=[...o,...f.map(d=>(d.path.unshift(c),d))];}else u!==p&&!(l&&(isNaN(u)?`${u}`==`${p}`:+u==+p))&&o.push({path:[c],type:"upd",value:p});}let a=Array.isArray(t);for(let s in t)s in e||o.push({type:"new",path:[a?+s:s],value:t[s]});return o}var Rn=e=>e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/'/g,"&apos;").replace(/"/g,"&quot;"),uu=e=>e.replace(/&lt;/gi,"<").replace(/&gt;/gi,">").replace(/&quot;/gi,'"').replace(/&apos;/gi,"'").replace(/&amp;/gi,"&");function lu(e,t,n=[]){return e.filter(r=>!t.some(o=>!o(r))).map(r=>{for(let o of n)r=o(r);return r}).filter(r=>r!=null)}function fu(e,t){return e.reduce((n,r)=>{let o=String(r[t]);return (n[o]=n[o]||[]).push(r),n},{})}function pu(e,t){return Array.from(e.reduce((n,r)=>n.add(r[t]),new Set))}function du(e,t){return e.map(n=>n[t])}function yu(e,t){return H(e)?Object.fromEntries(Object.entries(e).map(([n,r])=>{let o=t(n,r);return G(o)&&o.length===2?o:[n,o]}).filter(n=>n!=null)):{}}function hu(e,t){return t.dispose&&e.dispose&&t.dispose.add(e.dispose),Object.assign(e,t)}function xu(e){return Object.keys(e).length<=0}var Fn=/[\u0000-\u001F\u0080-\u009F]/g,po=/^\.+/,go=/\.+$/;function kn(){return /[<>:"/\\|?*\u0000-\u001F]/g}function mo(){return /^(con|prn|aux|nul|com\d|lpt\d)$/i}function In(e,t="_"){if(typeof e!="string")throw new TypeError("Expected a string");if(kn().test(t)&&Fn.test(t))throw new Error("Replacement string cannot contain reserved filename characters");return e=e.replace(kn(),t).replace(Fn,t).replace(po,t).replace(go,""),e=mo().test(e)?e+t:e,e.slice(0,100)}var yo=/[\\\-\[\]\/{}()*+?.^$|]/g;function Mn(e){return e?e instanceof RegExp?e.source:e.replace(yo,"\\$&"):""}var me=e=>Math.abs(e)%1===.5,Cn=e=>e%2===0,Lu=e=>Math.ceil(e),Au=e=>Math.floor(e),vu=e=>Math.round(e),Uu=e=>{let t=Math.round(e);return me(e)&&Cn(t)?t-1:t},Eu=e=>me(e)?Math.sign(e)*Math.ceil(Math.abs(e)):Math.round(e),Du=e=>me(e)?Math.floor(e):Math.round(e),Su=e=>{let t=Math.round(e);return me(e)?Cn(t)?t:t-1:t},Pu=e=>me(e)?Math.sign(e)*Math.floor(Math.abs(e)):Math.round(e);function Bn(e){return e.reduce((t,n)=>Math.min(t,n.sort_weight||0),0)-1-R()}function $n(e){return e.reduce((t,n)=>Math.max(t,n.sort_weight||0),0)+1+R()}function ku(e,t,n){let r=n.length,o=e<t;if(r<=0||e>=r-1)return $n(n);if(e<=0)return Bn(n);n=ho([...n]);let i=o?-1:0,a=n[e+i].sort_weight||0,u=(n[e+i+1].sort_weight||0)-a;if(u===0)return o?Bn(n):$n(n);let c=a+u/2,p=u*.01*(R()-.5);return c+p}function ho(e){return e.sort((t,n)=>(t.sort_weight||0)-(n.sort_weight||0)),e}function Cu(e={}){let{getter:t=s=>s.sort}=e;function n(s){return s.sort((u,c)=>(t(u)||0)-(t(c)||0)),s}function r(s){return s.reduce((u,c)=>Math.min(u,t(c)||0),0)-1-R()}function o(s){return s.reduce((u,c)=>Math.max(u,t(c)||0),0)+1+R()}function i(s,u){s==null&&(s=(u??0)-1),u==null&&(u=(s??0)+1);let c=u-s,p=s+c/2,l=c*.01*(R()-.5);return p+l}function a(s,u,c){let p=c.length,l=s<u;if(p<=0||s>=p-1)return o(c);if(s<=0)return r(c);c=n([...c]);let f=l?-1:0,d=t(c[s+f])||0,m=(t(c[s+f+1])||0)-d;if(m===0)return l?r(c):o(c);let b=d+m/2,y=m*.01*(R()-.5);return b+y}return {start:r,end:o,between:i,move:a,items:n}}var xo=/((?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00A1-\uFFFF][a-z0-9\u00A1-\uFFFF_-]{0,62})?[a-z0-9\u00A1-\uFFFF]\.)+(?:[a-z\u00A1-\uFFFF]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?)/gim;function Ou(e){return e.split(xo).map((t,n)=>{let r=Rn(t);return n%2?`<a target="_blank" href="${r}">${bo(r)}</a>`:r}).join("")}function bo(e){return e.replace(/^https?:\/\/(www\.)?/,"").replace(/\/$/,"")}function On(e){let t=[];for(let[n,r]of Object.entries(e))if(r!=null){Array.isArray(r)||(r=[r]);for(let o of r)o!=null&&t.push(`${encodeURIComponent(n)}=${encodeURIComponent(String(o))}`);}return t.join("&")}function _u(e){let t={},n=(e[0]==="?"?e.substr(1):e).split("&");for(let r=0;r<n.length;r++){let o=n[r].split("="),i=decodeURIComponent(o[0]),a=decodeURIComponent(o[1]||"");t[i]!=null?(Array.isArray(t[i])||(t[i]=[t[i]]),t[i].push(a)):t[i]=a;}return t}function Vu(e,t,n){let r=e[t];return r===void 0&&(r=n(t,e),e[t]=r),r}async function Hu(e,t,n){let r=e[t];return r===void 0&&(r=await n(t,e),e[t]=r),r}function Gu(e){return e!=null?e.size!=null?e.size:e.length!=null?e.length:Object.keys(e).length:0}function zu(e){return e!=null&&e.length>0?e[e.length-1]:void 0}function Wu(e){try{if(e!=null)return Array.isArray(e)||typeof e=="string"?e.length<=0:e?.size!=null?e.size<=0:Object.keys(e).length<=0}catch(t){console.warn("Failed to check if empty for",e,t);}return !0}function ue(e){return Object(e)!==e?e:JSON.parse(I(e))}function qu(e){return Object(e)!==e?e:JSON.parse(I(e))}function Ju(e){let t=new Map;return n=>{if(t.has(n))return t.get(n);let r=e(n);return t.set(n,r),r}}function Zu(e){let t=new Map;return async(...n)=>{let r=I(n);if(t.has(r))return t.get(r);let o=await e(...n);return t.set(r,o),o}}function Ku(e,t){let n=[];for(let r=0;r<e;r++)n.push(t(r,e));return n}var wo=/\\\s|\s+|#[^\n]*\n?/gm,To=/\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm,_n=/^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;function Lo(e){return typeof e=="string"?e:e.source||""}function Qu(e){return e.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}var jn=class{constructor(t,n){this.namedGroups={};this.names=[];let r=n??"",o;if(t instanceof RegExp?(n==null&&(r=t.flags),o=t.source):o=t,r&&r.includes("x")&&(r=r.replace("x",""),o=o.replace(wo,s=>s[0]==="\\"?s:"")),!(t instanceof RegExp)){let s=0;o=o.replace(To,(u,c)=>(s+=1,c?(c!=="index"&&c!=="length"&&!this.namedGroups[c]&&(this.namedGroups[c]=s),"("):u)),this.names=Object.keys(this.namedGroups);}o=Lo(o),_n.lastIndex=0;let a=_n.exec(o);a&&(this.lookBehind={rx:new RegExp(`${a[3]}$(?!\\s)`),expect:a?a[2]==="=":!a},o=o.substr(a[0].length)),this.rx=new RegExp(o,r);}get lastIndex(){return this.rx.lastIndex}set lastIndex(t){this.rx.lastIndex=t;}_handleMatch(t){if(this.lookBehind){let n=t.input.slice(0,t.index);if(this.lookBehind.expect!==this.lookBehind.rx.test(n))return null}for(let n of this.names)t[n]=t[this.namedGroups[n]];return t}exec(t){let n;for(;n=this.rx.exec(t);)if(this.rx.lastIndex===n.index&&this.rx.lastIndex++,n=this._handleMatch(n),n!=null)return n}execAll(t){let n=[],r;for(this.rx.lastIndex=0;r=this.exec(t);)n.push(r);return this.rx.lastIndex=0,n}replace(t,n){let r=typeof n=="function"?n:()=>n;return t.replace(this.rx,o=>r(o))}};var Ao=",";function tc(e,t={}){let{separator:n=Ao}=t,r="";for(let o=0;o<e.length;o++)r+=`${e[o].map(i=>{if(i==null||i==="")return "";if(Sn(i))return i?1:0;let a=String(i);return (je(i)||G(i))&&(a=I(i)),a.includes('"')||a.includes(`
`)||a.includes(n)?`"${a.replace(/"/g,'""')}"`:a}).join(n)}
`;return r}function vo(e,t={}){let n=/("((?:(?:[^"]*?)(?:"")?)*)"|([^,;\t\n]*))([,;\t]|\n|\r\n)/g;t.separator&&(n=new RegExp(n.source.replaceAll(",;\\t",Mn(t.separator)),n.flags));let r=[],o=[],i,a=`${e.replaceAll(`\r
`,`
`).trim()}
`;for(;i=n.exec(a);){let s=i[2]??i[3]??"";s=s.replaceAll('""','"'),o.push(s),i[4]===`
`&&(r.push(o),o=[]);}return r}function nc(e,t={}){let n=vo(e,t),r=n[0];return n.slice(1).map(o=>Object.fromEntries(o.map((i,a)=>[r[a],i])))}async function Uo(e){typeof e=="function"?await V(e()):M(e)?await e:typeof e.dispose=="function"?await V(e.dispose()):M(e.dispose)?await e.dispose:typeof e.cleanup=="function"?await V(e.cleanup()):M(e.cleanup)&&await e.cleanup;}function ye(e){let t=e;t!=null&&(En(t)?t={name:t}:"debug"in t&&"label"in t&&(t={name:t.label,log:t}));let n=t?.name,r=t?.log??k("zeed:dispose"),o=[],i=async u=>{u!=null&&o.includes(u)&&(gt(o,c=>c!==u),await Uo(u));},a=async()=>{for(n&&r.debug(`dispose "${n}": ${o.length} entries`);o.length>0;)await i(o[0]);},s=u=>{if(u!=null)return o.unshift(u),()=>i(u)};return Object.assign(a,{track:s,add:s,untrack:i,dispose:a,exec:a,getSize(){return o.length},isDisposed(){return o.length<=0}})}var uc=ye;function cc(e={}){let{mode:t="fifo"}=e,n=[],r=async(i=!1)=>{for(;n.length>0;){let a=n[0];if(gt(n,s=>s!==a),typeof a=="function"){let s=a();if(M(s)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await s;}}else if(M(a)){if(i)throw new Error(`Expected sync only function, but found async: ${a}`);await a;}else throw new Error(`Unhandled disposable: ${a}`)}};return Object.assign(r,{add:i=>{t==="lifo"?n.unshift(i):n.push(i);},exec:r,getSize(){return n.length}})}function lc(e,t=0){let n=setTimeout(e,t);return ()=>{n&&(clearTimeout(n),n=void 0);}}function fc(e,t){let n=setInterval(e,t);return ()=>{n&&(clearInterval(n),n=void 0);}}function pc(e,t,n,...r){return e==null?()=>{}:(e.on?e.on(t,n,...r):e.addEventListener&&e.addEventListener(t,n,...r),()=>{e.off?e.off(t,n,...r):e.removeEventListener&&e.removeEventListener(t,n,...r);})}function mc(){let e=!0;return (t,n)=>{let r=!1;if(e){e=!1;try{t(),r=!0;}finally{e=!0;}}else n!==void 0&&n();return r}}function yc(){let e=!0;return async(t,n)=>{let r=!1;if(e){e=!1;try{let o=t();M(o)&&await o,r=!0;}finally{e=!0;}}else if(n!==void 0){let o=n();M(o)&&await o;}return r}}var C=class{constructor(){this.subscribers={};this.subscribersOnAny=[];this._logEmitter=k("zeed:emitter","error");this.dispose=ye();this.call=new Proxy({},{get:(t,n)=>async(...r)=>await this.emit(n,...r)});}async emit(t,...n){let r=!1;try{let o=this.subscribers[t]||[];if(this._logEmitter.debug("emit",this?.constructor?.name,t,...n,o),this.subscribersOnAny.forEach(i=>i(t,...n)),o.length>0){let i=o.map(a=>{try{return V(a(...n))}catch(s){this._logEmitter.warn("emit warning:",s);}return null}).filter(a=>a!=null);r=!0,await Promise.all(i);}}catch(o){this._logEmitter.error("emit exception",o);}return r}onAny(t){this.subscribersOnAny.push(t);}on(t,n){let r=this.subscribers[t]||[];return r.push(n),this.subscribers[t]=r,()=>{this.off(t,n);}}onCall(t){for(let[n,r]of Object.entries(t))this.on(n,r);}once(t,n){let r=async(...o)=>(this.off(t,r),await V(n(...o)));return this.on(t,r),()=>{this.off(t,n);}}off(t,n){return this.subscribers[t]=(this.subscribers[t]||[]).filter(r=>n&&r!==n),this}removeAllListeners(){return this.subscribers={},this}};function Ac(){let e=Q().emitter;return e||(e=new C,Q().emitter=e),e}function vc(e,t){let n=Math.round(R()*100),r=[],o,i=(s,u)=>{let c={key:s,obj:u};r.push(c),o&&o();};return t?e.on?e.on(t,s=>{i(t,s);}):e.addEventListener?e.addEventListener(t,s=>{i(t,s);}):e.log.error(n,"Cannot listen to key"):e.onAny?e.onAny((s,u)=>{i(s,u);}):e.log.error(n,"cannot listen to all for",e),(s,u=!0)=>new Promise((c,p)=>{s||(s=t,s||r.length&&(s=r[0].key)),o=()=>{for(;r.length>0;){let l=r.shift();if(l.key===s)o=void 0,c(l.obj);else {if(u)continue;p(new Error(`Expected ${s}, but found ${l.key} with value=${l.obj}`));}break}},o();})}var he=()=>Date.now();function Lt(e){return e>999?`${(e/1e3).toFixed(1)}s`:`${e.toFixed(2)}ms`}function Ec(...e){for(let t of e){if(t instanceof Date)return t;if(typeof t=="string"){let n=null;if(t.includes(":"))try{n=new Date(t);}catch{}if(!(n instanceof Date)){let r=/(\d\d\d\d)-(\d\d)-(\d\d)/.exec(t);r&&(n=new Date(+r[1],+r[2]-1,+r[3],12,0));}if(n instanceof Date)return n}}}var Nn=()=>typeof performance<"u"?performance.now():Date.now();function Dc(){let e=Nn();return function(){let t=Nn()-e;return Lt(t)}}var Ve=16;function vt(){return ie(Ve)}function Eo(e=vt()){return yt(e,22)}function Do(e){return yt(e,22)}function So(e){return yn(e,Ve)}function Po(e=vt()){return mt(e,26)}function Ro(e){return mt(e,26)}function Fo(e){return mn(e,Ve)}var ko="10000000-1000-4000-8000-100000000000",Io=function(){return typeof crypto<"u"&&crypto.randomUUID!=null?crypto.randomUUID():ko.replace(/[018]/g,e=>(e^ie(1)[0]&15>>e/4).toString(16))};function Mo(e){let t=Gt(e);return `${t.slice(0,8)}-${t.slice(8,12)}-${t.slice(12,16)}-${t.slice(16)}`}function Co(e){return zt(e.replaceAll("-",""))}var Vn=16e11;function Bo(e){let t=new Uint8Array([0,0,0,0,0,0]),n=t.length-1;for(let r=0;r<t.length;r++){let o=e&255;t[n-r]=o,e=(e-o)/256;}return t}function Hn(){let e=he()-Vn;return new Uint8Array([...Bo(e),...ie(10)])}function Ic(){return Oo(Hn())}function Mc(e){return $o(zn(e))}function $o(e){return new Date(Vn+e.slice(0,6).reduce((t,n)=>t*256+n,0))}function Cc(){return new Uint32Array(ie(4))[0]}var Ut={base62:{uuid:Eo,uuidDecode:So,uuidEncode:Do},base32:{uuid:Po,uuidDecode:Fo,uuidEncode:Ro},uuidv4:{uuid:Io,uuidDecode:Co,uuidEncode:Mo}},He="base62",Gn=!1;function Bc(e,t=!1){He=e,Gn=t;}function K(){return Ut[He].uuid(Gn?Hn():vt())}function zn(e){return Ut[He].uuidDecode(e)}function Oo(e){return Ut[He].uuidEncode(e)}function $c(e){try{return zn(e).length===Ve}catch{}return !1}var At={};function _(e="id"){return At[e]==null&&(At[e]=0),`${e}-${At[e]++}`}var _o=0;function Oc(){return `id-${_o++}`}var Et=class extends C{constructor(){super(...arguments);this.id=K();}close(){this.dispose();}},Ge=class extends Et{constructor(){super(...arguments);this.isConnected=!0;}postMessage(n){this.other?.emit("message",{data:n,origin:"local",lastEventId:K()});}};function Vc(){let e=new Ge,t=new Ge;return e.other=t,t.other=e,[e,t]}var Wn=class{async encode(t){return t}async decode(t){return t}},ce=class{async encode(t){return Qe(t)}async decode(t){return Xe(t)}},qn=class{constructor(t){this.key=t;}async encode(t){let n=Qe(t);return await fn(n,this.key)}async decode(t){let n=await pn(t,this.key);return Xe(n)}};var Jn=(e,t,n={})=>new Proxy(n,{get:(r,o)=>o in r?r[o]:(...i)=>e(o,i,t)});function Qc(e={}){let{name:t=_("hub"),encoder:n=new ce,retryAfter:r=1e3,ignoreUnhandled:o=!0,logLevel:i=!1}=e,a=k(t,i),s={},u,c=[],p,l={},f=()=>{clearTimeout(p);},d=async()=>{if(clearTimeout(p),u){if(u.isConnected)for(;c.length;){let y=c[0];try{u.postMessage(await n.encode(y)),c.shift();}catch(T){a.warn("postMessage",T);break}}c.length>0&&r>0&&(p=setTimeout(d,r));}},g=async y=>{a("enqueue postMessage",y),c.push(y),await d();},m=async y=>{u=y,u.on("connect",d),u.on("message",async T=>{a("onmessage",typeof T);let{name:v,args:D,id:h,result:x,error:L}=await n.decode(T.data);if(v){a(`name ${v} id ${h}`);try{if(s[v]==null)throw new Error(`handler for ${v} was not found`);let U=s[v](...D);M(U)&&(U=await U),a(`result ${U}`),h&&await g({id:h,result:U});}catch(U){let w=U instanceof Error?U:new Error(ht(U));a.warn("execution error",w.name),await g({id:h,error:{message:w.message,stack:w.stack,name:w.name}});}}else if(h)if(a(`response for id=${h}: result=${x}, error=${L}`),l[h]==null)x===void 0?a(`skip response for ${h}`):a.warn(`no response hook for ${h}`);else {let[U,w]=l[h];if(U&&w)if(delete l[h],L){let P=new Error(L.message);P.stack=L.stack,P.name=L.name,a.warn("reject",P.name),w(P);}else a("resolve",x),U(x);}else o||a.warn("Unhandled message",T);}),await d();},b=async(y,T,v={})=>{let{timeout:D=5e3}=v,h=K();return await g({name:y,args:T,id:h}),Un(new Promise((x,L)=>l[h]=[x,L]),D)};return e.channel&&m(e.channel),{dispose:f,connect:m,listen(y){Object.assign(s,y);},send(){return Jn(b,{},{options(y){return Jn(b,{...y})}})}}}var Dt=class extends C{constructor(n){super();this.publish=this.emit.bind(this);this.subscribe=this.on.bind(this);let{name:r,encoder:o=new ce,channel:i,debug:a=!1}=n;this.channel=i,this.encoder=o,this.debug=a,this.name=r??this.channel.id??_("pubsub"),this.log=k(`${this.shortId}`),this.debug&&(this.channel.on("connect",()=>{this.log("channel connected");}),this.channel.on("disconnect",()=>{this.log("channel disconnected");})),this.channel.on("message",async({data:s})=>{let u=await this.encoder.decode(s);if(this.debug?this.log(`channel message, event=${u?.event}, info=`,u):this.log(`channel message, event=${u?.event}`),u){let{event:c,args:p}=u;await this.emitSuper(c,...p);}});}get shortId(){return this.name.substr(0,6)}async emitSuper(n,...r){return await super.emit(n,...r)}async emit(n,...r){try{if(this.debug?this.log(`emit(${String(n)})`,n):this.log(`emit(${String(n)})`,r.length),!this.channel.isConnected)return this.log.warn("channel not connected"),!1;let o=await this.encoder.encode({event:n,args:r});return this.channel.postMessage(o),!0}catch(o){this.log.warn(`emit(${String(n)})`,o);}return !1}};function ol(e){return new Dt(e)}var jo=1;var Zn=e=>e,No=Zn;function sl(e,t){let{post:n,on:r,eventNames:o=[],serialize:i=Zn,deserialize:a=No}=t,s=new Map;return r(async u=>{let c=a(u),[p,l,f,d]=c;if(p===1||p===2){let g,m;if(d!=null)try{let b=e[d];g=await b(...l);}catch(b){m=String(b);}else m="Method implementation missing";p===1&&f&&n(i(m?[4,m,f]:[3,g,f]));}else if(f){let g=s.get(f);g!=null&&(p===4?g.reject(l):g.resolve(l)),s.delete(f);}}),new Proxy({},{get(u,c){let p=(...f)=>{n(i([2,f,null,c]));};if(t.onlyEvents||o.includes(c))return p.asEvent=p,p;let l=(...f)=>new Promise((d,g)=>{let m=jo++;s.set(m,{resolve:d,reject:g}),n(i([1,f,m,c]));});return l.asEvent=p,l}})}var Y=class extends C{constructor(n={}){super();this._isCancelled=!1;this._resetWhenFinished=!0;this._children=[];this._totalUnits=n.totalUnits??0,this._completedUnits=n.completeUnits??0,this._resetWhenFinished=n.resetWhenFinished??!0,this.name=n.name??_("progress"),this.dispose.add(async()=>{for(let r of this._children)await r.dispose();await this.emit("progressDispose",this);});}update(){this.emit("progressChanged",this),this._isCancelled&&this._resetWhenFinished&&this.getTotalUnits()<=this.getCompletedUnits()&&this.reset();}reset(){if(this._isCancelled){this._isCancelled=!1;for(let n of this._children)n.reset();this.update();}}async cancel(){if(!this._isCancelled){this._isCancelled=!0,await this.emit("progressCancelled",this);for(let n of this._children)await n.cancel();this.update();}}addChild(n){n.on("progressDispose",()=>this.removeChild(n)),n.on("progressChanged",()=>this.update()),this._children.includes(n)||this._children.push(n),this.update();}createChildProgress(n){let r=new Y(n);return this.addChild(r),r}removeChild(n){dn(this._children,n),this.update();}getTotalUnits(){if(this.isIndeterminate())return 0;let n=this._totalUnits;for(let r of this._children)n+=r.getTotalUnits();return n}getCompletedUnits(){if(this.isIndeterminate())return 0;let n=this._completedUnits;for(let r of this._children)n+=r.getCompletedUnits();return n}isIndeterminate(){return this._totalUnits<=0&&this._children.length<=0}isCancelled(){return this._isCancelled}isFinished(){return this.dispose.isDisposed()||!this.isIndeterminate()&&this.getTotalUnits()<=this.getCompletedUnits()}getFraction(){if(this.isIndeterminate())return 0;let n=this.getCompletedUnits()/this.getTotalUnits();return isNaN(n)&&(n=0),Math.min(1,Math.max(0,n))}getChildrenCount(){return this._children.length}setTotalUnits(n,r){this._totalUnits=n,r!=null&&(this._completedUnits=r),this.update();}incTotalUnits(n=1){this._totalUnits+=n,this.update();}setCompletetedUnits(n){this._completedUnits=n,this.update();}setCompleted(){this._completedUnits=this._totalUnits,this.update();}incCompletedUnits(n=1){this._completedUnits+=n,this.update();}toString(n=0){let r=`${"  ".repeat(n)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction()*100)} %, cancel=${this._isCancelled}
`;for(let o of this._children)r+=o.toString(n+1);return n===0?r.trim():r}};function hl(e={}){let{maxParallel:t=3,name:n=_("pool"),idConflictResolution:r="memoize"}=e,o=new C,i=ye();i.add(T);let a=new Y({name:n});a.on("progressCancelled",T);let s=0,u=0,c=0,p=0,l={};async function f(){if(s>0){let[h,x]=vn();return o.once("didFinish",x),h}}async function d(){for(let h of Object.keys(l))l[h].state==="finished"&&(await l[h].progress.dispose(),delete l[h]);}function g(){o.emit("didFinish"),s=0,u=0,d(),a.reset();}function m(){let h=0,x=0;for(let{max:L,resolved:U,state:w}of Object.values(l))h+=L,x+=w==="finished"?L:Math.min(L,U);o.emit("didUpdate",s,u,h,x);}function b(){if(m(),s>0&&s===u&&g(),c>=t)return;let h=Object.values(l).filter(x=>x.state==="waiting");if(h.length>0){let x;for(let L of h)L.group!=null&&Object.values(l).some(U=>U.state==="running"&&U.id!==L.id&&U.group===L.group)||(x==null||L.priority<x.priority)&&(x=L);if(x!=null){let L=x.id,U=x.done;x.state="running",++c,o.emit("didStart",L);let w=P=>{x&&(x.result=P,x.state="finished",x.resolved=x.max,x.progress?.setCompleted()),--c,++u,b();};x.task(x).then(P=>{U(P),o.emit("didResolve",L,P),w(P);}).catch(P=>{U(),o.emit("didReject",L,P),w();});}}}function y(h){let x=l[h];x&&x.state==="waiting"&&(l[h].state="finished",++u,o.emit("didCancel",h),l[h].progress.dispose(),m());}function T(){Object.keys(l).forEach(y);}function v(h){return l[h]!=null}function D(h,x={}){let L,U=new Promise(F=>L=F),w=x.id??K();if(l[w]!=null){let F=x.idConflictResolution??r;if(F==="replace")y(w);else if(F==="memoize"||F==="prioritize"){let Bt=l[w];return F==="prioritize"&&(Bt.priority=++p),{id:w,promise:(async()=>{if(Bt.state==="finished")return l[w].result})(),dispose:()=>y(w),cancel:()=>y(w)}}else throw new Error(`Pool task with id=${w} already exists!`)}let P=new Y({name:w,totalUnits:x.max??1,completeUnits:x.resolved??0});return a.addChild(P),l[w]={id:w,task:h,priority:++p,group:x.group,state:"waiting",max:x.max??1,resolved:x.resolved??0,done:L,payload:x.payload,progress:P,setMax(F){P.setTotalUnits(F),l[w].max=F,m();},setResolved(F){P.setCompletetedUnits(F),l[w].resolved=F,m();},incResolved(F=1){P.incCompletedUnits(F),l[w].resolved+=F,m();}},++s,b(),{id:w,promise:U,dispose:()=>y(w),cancel:()=>y(w)}}return {events:o,cancel:y,cancelAll:T,hasById:v,progress:a,enqueue:D,dispose:i,waitFinishAll:f}}var Kn=class extends C{constructor(n={}){super();this.queue=[];this.waitToFinish=[];this.countMax=0;this.countResolved=0;this.paused=!1;let{name:r=_("queue"),logLevel:o}=n;this.name=r,this.log=k(`zeed:queue:${r}`,o??X);}async performNext(){if(this.log("performNext, queue.length =",this.queue.length),this.currentTask!=null){this.log("performNext => skip while another task is running");return}if(this.paused){this.log("performNext => skip while is paused");return}for(;this.currentTask==null&&!this.paused;){let n=this.queue.shift();if(this.log(`performNext => ${n?.name}`),n==null)break;this.countResolved===0&&this.emit("didStart",this.countMax);let{name:r,task:o,resolve:i}=n;this.currentTask=o();let a;try{this.log.info(`start task ${r}`),a=await this.currentTask,this.log(`finished task ${r} with result =`,a);}catch(s){this.log.warn("Error performing task",s);}i(a),this.currentTask=void 0,this.countResolved+=1,this.emit("didUpdate",this.countMax,this.countResolved);}for(this.queue.length===0&&(this.emit("didFinish"),this.countMax=0,this.countResolved=0);this.waitToFinish.length>0;)this.waitToFinish.shift()();}async enqueue(n,r={}){let{immediate:o=!1,name:i=_(this.name)}=r;return o?(this.log.info(`immediate execution ${i}`),await n()):(this.log(`enqueue ${i}`),new Promise(a=>{this.queue.push({name:i,task:n,resolve:a}),this.countMax+=1,this.emit("didUpdate",this.countMax,this.countResolved),this.performNext();}))}async enqueueReentrant(n,r={}){return this.enqueue(n,{immediate:this.currentTask!=null,name:r.name})}async cancelAll(n=!0){this.log("cancelAll"),this.emit("didCancel");let r=this.queue.map(o=>o.resolve);this.queue=[],r.forEach(o=>o(void 0)),await this.wait();}async pause(){this.log("pause"),this.paused=!0,await this.wait();}resume(){this.log("resume"),this.paused=!1,this.performNext();}async wait(){if(this.log("wait"),!(this.currentTask==null&&(this.queue.length===0||this.paused)))return new Promise(n=>{this.waitToFinish.push(n);})}get isPaused(){return this.paused}get hasTasks(){return this.queue.length!==0}};function Ul(e,t={}){let {delay:n=100,trailing:r=!0,leading:o=!0}=t,i=0,a=0,s=0,u;function p(){return i?(clearTimeout(i),i=void 0,!0):!1}function l(...f){let d=Date.now(),g=d-a,m=()=>{s=0,a=Date.now(),e.apply(this,f);};if(u=m,g>n||!i){o&&(g>n?m():++s);let b=g>n?n:n-g;p(),a=d,i=setTimeout(()=>{i=0,r&&(!o||s>0)&&u?.();},b);}else ++s;}return l.cancel=p,l.stop=()=>{p()&&u&&u();},l.immediate=async function(...d){p(),a=Date.now(),e.apply(this,d);},l.dispose=()=>l.stop(),l}function El(e,t={}){let{delay:n=100}=t,r=0,o=!1,i;function a(){r&&(clearTimeout(r),r=0);}async function s(){try{if(a(),i!=null){let p=[...i];i=void 0,o=!0,await V(e(...p)),o=!1,i!=null&&(a(),r=setTimeout(s,n));}}catch{}}function u(...p){i=[...p],a(),o===!1&&(r=setTimeout(s,n));}async function c(...p){a(),i=[...p],await s();}return u.cancel=a,u.dispose=a,u.immediate=c,u}function Sl(e=globalThis?.location?.hostname??""){return ["::ffff:127.0.0.1","localhost","127.0.0.1","","::1","::"].includes(e)||e.startsWith("192.168.")||e.startsWith("10.0.")||e.endsWith(".local")}function Fl(e){let{level:t=void 0,filter:n=void 0,messages:r=[]}=e,o=j(n),i=z(t);return a=>{i(a.level)&&o(a.name)&&r.push(a);}}var St={cache:"no-cache",redirect:"follow",headers:{}};function Vo(e){let t=/:\/\/([^@]*)@/gi.exec(e);if(t&&t[1]){let[n,r]=t[1].split(":",2);return {url:e.replace(`${t[1]}@`,""),username:n,password:r}}}async function Yn(e,t={},n=fetch){try{G(t)&&(t=Ne({},...se(t)));let r=Vo(String(e));r&&(e=r.url,t=Ne({},t,Ho(r.username,r.password))),t.headers!=null&&!(t.headers instanceof Headers)&&(t.headers=new Headers(t.headers));let o=await n(String(e),t);if(o.status<400)return o;let i=k("zeed:network");try{i.warn(`Fetch of ${String(e)} returned status=${o.status}. Options:`,t),i.warn(`Response: ${await o.text()}`);}catch(a){i.error("Exception:",a);}}catch(r){k("zeed:network").error("fetchBasic",r);}}async function Bl(e,t={},n=fetch){try{let r=await Yn(e,[{method:"GET",headers:{Accept:"application/json"}},t],n);if(r)return await r.json()}catch(r){k("zeed:network").error("fetchJSON error:",r);}}async function $l(e,t={},n=fetch){try{let r=await Yn(e,[St,{method:"GET"},t],n);if(r)return await r.text()}catch(r){k("zeed:network").error("fetchHTML error:",r);}}function Ol(e,t="POST"){return {method:t,...St,headers:{"Content-Type":"application/x-www-form-urlencoded; charset=utf-8"},body:On(e)}}function _l(e,t="POST"){return {method:t,...St,headers:{"Content-Type":"application/json; charset=utf-8"},body:I(e)}}function Ho(e,t){return {headers:{Authorization:`Basic ${le(`${e}:${t}`)}`}}}function Qn(){if(typeof window<"u")return window}function Go(){if(typeof navigator<"u")return navigator}function Nl(){return Qn()??typeof WorkerGlobalScope<"u"?self:typeof global<"u"?global:Function("return this;")()}function Vl(e={ios:!1,macos:!1,windows:!1,beaker:!1,electron:!1,wkwebview:!1,pwa:!1,pwaInstalled:!1,browser:!1,node:!1,worker:!1,test:!1,jest:!1,macosNative:!1,iosNative:!1,appleNative:!1,touch:!1}){let t=Go(),n=Qn();return e.ios=t?.platform?.match(/(iPhone|iPod|iPad)/i)!=null,e.macos=!!t?.platform?.startsWith("Mac"),e.windows=!!t?.platform?.startsWith("Win"),e.beaker=n?.beaker!=null,e.electron=(t?.userAgent?.toLowerCase()?.indexOf(" electron/")||-1)>-1&&!e.beaker,e.wkwebview=n?.webkit?.messageHandlers!=null,e.pwa=t?.serviceWorker!=null,e.pwaInstalled=t?.standalone||n?.matchMedia?.("(display-mode: standalone)")?.matches,e.node=typeof process<"u"&&process?.release?.name==="node",e.browser=!e.electron&&!e.wkwebview&&!e.node,e.worker=typeof WorkerGlobalScope<"u"&&self instanceof WorkerGlobalScope,e.jest=typeof jest<"u"||typeof vitest<"u",e.test=e.jest,e.macosNative=e.wkwebview&&e.macos,e.iosNative=e.wkwebview&&e.ios,e.appleNative=e.wkwebview,e.touch=n&&"ontouchstart"in n||(t?.maxTouchPoints||0)>1||t?.msPointerEnabled&&n?.MSGesture||n?.DocumentTouch&&document instanceof DocumentTouch,e}function zo(){return typeof window<"u"&&globalThis===window}function Hl(e){zo()?window.addEventListener("beforeunload",e):typeof process<"u"&&process.on("exit",()=>e);}var Xn=class{constructor(t={}){this.store={};}setItem(t,n){this.store[t]=ue(n);}getItem(t){return ue(this.store[t])}removeItem(t){delete this.store[t];}clear(){this.store={};}allKeys(){return Object.keys(this.store)}};var ql=()=>{};function Kl(e={}){let{args:t=process.argv.slice(1),alias:n={},normalize:r=hn,booleanArgs:o=[],listArgs:i=[],numberArgs:a=[]}=e,s=Object.entries(n).reduce((f,d)=>{let[g,m]=d;typeof m=="string"&&(m=[m]);for(let b of m)f[r(b)]=r(g);return f},{}),u={_:[]};function c(f,d){u[f]==null||typeof u[f]=="boolean"?u[f]=d:Array.isArray(u[f])?u[f].push(d):u[f]=[u[f],d];}let p=[...t],l;for(;l=p.shift();){let f;if(/^--?/.test(l)){let d=l.replace(/^--?/,"");if(l.includes("=")){let[g,m]=d.split("=",2);d=g.trim(),f=m.trim();}d=r(d),d=s[d]??d,o.includes(d)?c(d,!0):(f=f??p.shift()??"",a.includes(d)&&(f=Number(f??0)),i.includes(d)?Array.isArray(u[d])?u[d].push(f):u[d]=[f]:c(d,f));}else u._.push(l);}return u}function Ql(e){return new Promise((t,n)=>{import('child_process').then(({spawn:r})=>{let o=r("pbcopy");o.on("error",i=>n(i)),o.on("close",()=>t(e)),o.stdin.write(e),o.stdin.end();}).catch(()=>{});})}function tf(){try{typeof globalThis<"u"&&typeof globalThis.crypto>"u"&&Pt__default.default&&Pt__default.default.webcrypto&&(globalThis.crypto=Pt__default.default.webcrypto);}catch(e){console.warn("Failed to polyfill webcrypto",e);}}async function nf(){if(globalThis.crypto==null)try{if(typeof globalThis<"u"&&typeof globalThis.crypto>"u"){let e=await import('crypto');globalThis.crypto=e.webcrypto;}}catch(e){console.warn("Failed to polyfill webcrypto",e);}return globalThis.crypto}var qo=`
`,Jo=/^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/,Zo=/\\n/g,Ko=/\n|\r|\r\n/;function er(e,t={}){let n={};return String(e).split(Ko).forEach((r,o)=>{let i=r.match(Jo);if(i!=null){let a=i[1],s=i[2]||"",u=s.length-1,c=s[0]==='"'&&s[u]==='"';s[0]==="'"&&s[u]==="'"||c?(s=s.substring(1,u),c&&(s=s.replace(Zo,qo))):s=s.trim(),n[a]=s;}}),n}function Yo(e,t="."){return path.resolve(process.cwd(),e??t)}function Qo(e,t=""){return e==null&&(e=t),Yo(String(e).trim(),t)}var Rt=Qo;function af(e,t=process.env){if(t[e]!=null)return t[e];e=e.toLowerCase();for(let[n,r]of Object.entries(t))if(n.toLowerCase()===e)return r}function uf(e={}){let t=e?.path??Rt(e?.filename??".env"),n=e?.encoding??"utf8",r=e?.debug||!1;try{let o=ze__default.default.existsSync(t)?er(ze__default.default.readFileSync(t,{encoding:n}),{debug:r}):{},i=ze__default.default.existsSync(`${t}.local`)?er(ze__default.default.readFileSync(`${t}.local`,{encoding:n}),{debug:r}):{},a=Object.assign({},o,i),s=e?.env??process.env;return Object.entries(a).forEach(([u,c])=>{typeof e?.prefix=="string"&&(u=e?.prefix+u),Object.prototype.hasOwnProperty.call(s,u)||c!=null&&(s[u]=c);}),{parsed:a}}catch(o){return {error:o}}}function pf(e){let t=path.normalize(e),n=process.env.HOME;return n&&t.startsWith(n)?`~${t.slice(n.length)}`:t}async function kt(e){try{await promises.stat(e);}catch{return !1}return !0}function We(e){return e.startsWith(".")||e.includes("/.")}async function df(...e){let t=path.join(...e);return await kt(t)||await promises.mkdir(t,{recursive:!0}),t}async function gf(...e){let t=path.join(...e);return await kt(t)&&await promises.rm(t,{recursive:!0}),t}async function mf(...e){let t=path.join(...e);if(await kt(t))return await promises.readFile(t,"utf-8")}async function yf(e,t){await promises.writeFile(e,t,"utf-8");}function qe(e,t){if(typeof e!="string")throw new TypeError("Expected a string");let n=String(e),r="",o=t?!!t.extended:!1,i=t?!!t.globstar:!1,a=!1,s=t&&typeof t.flags=="string"?t.flags:"",u;for(let c=0,p=n.length;c<p;c++)switch(u=n[c],u){case"/":case"$":case"^":case"+":case".":case"(":case")":case"=":case"!":case"|":r+=`\\${u}`;break;case"?":o&&(r+=".");break;case"[":case"]":o&&(r+=u);break;case"{":o&&(a=!0,r+="(");break;case"}":o&&(a=!1,r+=")");break;case",":a?r+="|":r+=`\\${u}`;break;case"*":{let l=n[c-1],f=1;for(;n[c+1]==="*";)f++,c++;let d=n[c+1];i?f>1&&(l==="/"||l===void 0)&&(d==="/"||d===void 0)?(r+="((?:[^/]*(?:/|$))*)",c++):r+="([^/]*)":r+=".*";}break;default:r+=u;}return (!s||!~s.indexOf("g"))&&(r=`^${r}$`),new RegExp(r,s)}function nr(e){try{return ze.statSync(e)}catch{}}function Af(e){let{mtimeMs:t,size:n}=nr(e)??{};return `${e}|${t}|${n}`}function rr(e,t="",n=!0){let r=[],o=ze.readdirSync(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&We(i))continue;let a=path.join(e,i),s=nr(a);s&&s.isDirectory()?r=r.concat(rr(e,i)||[]):r.push(i);}return r}function vf(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=rr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=qe(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}async function ir(e){try{return await promises.stat(e)}catch{}}async function Rf(e){let{mtimeMs:t,size:n}=await ir(e)??{};return `${e}|${t}|${n}`}async function sr(e,t="",n=!0){let r=[],o=await promises.readdir(path.resolve(e,t));if(o!=null&&o.length>0)for(let i of o){if(i=path.join(t,i),n&&We(i))continue;let a=path.join(e,i),s=await ir(a);s&&s.isDirectory()?r=r.concat(await sr(e,i)||[]):r.push(i);}return r}async function Ff(e={}){let{pattern:t,filter:n,basePath:r=process.cwd(),ignoreHidden:o=!1}=e,i=await sr(r,"",o);if(i=i.filter(a=>!(o&&(a.startsWith(".")||a.includes("/.")))),t&&(typeof t=="string"&&(t=qe(t)),t instanceof RegExp)){let a=t;a.lastIndex=0,i=i.filter(s=>a.test(s));}return n&&(i=i.filter(n)),i}var cr=class{constructor(t={}){this.store={};this.fileKeys=void 0;this.pretty=!1;this.dirname=path.resolve(process.cwd(),t.path??".fileStorage"),this.pretty=!!t.pretty,this.extension=t.extension??".json",t.extension&&!this.extension.startsWith(".")&&(this.extension=`.${this.extension}`),this.extensionLength=this.extension.length,this.objectToString=t.objectToString??(n=>this.pretty?I(n,null,2):I(n)),this.objectFromString=t.objectFromString??(n=>{try{return JSON.parse(n)}catch{}}),this.keyToFilename=t.keyToFilename??In;}setItem(t,n){this.store[t]=ue(n);try{let r=this.objectToString(n),o=this.getPath(t);ze.mkdirSync(path.dirname(o),{recursive:!0}),ze.writeFileSync(o,r,"utf8");}catch{}}getPath(t){return path.resolve(this.dirname,this.keyToFilename(t)+this.extension)}getBuffer(t){let n=this.getPath(t);return Buffer.from(ze.readFileSync(n))}getItem(t){let n=this.store[t];if(n!==null){if(n!=null)return ue(n);try{let r=this.getPath(t),o=ze.readFileSync(r,"utf8");if(o!=null){let i=this.objectFromString(o);return this.store[t]=i,i}}catch{this.store[t]=null;}}}removeItem(t){if(delete this.store[t],this.fileKeys!=null){let n=this.fileKeys.indexOf(t);n!==-1&&this.fileKeys.splice(n,1);}try{let n=this.getPath(t);ze.unlinkSync(n);}catch{}}clear(){this.fileKeys=[],this.store={},ze.rmSync(this.dirname,{recursive:!0,force:!0});}allKeys(){if(this.fileKeys==null)try{this.fileKeys=ze.readdirSync(this.dirname,{withFileTypes:!0}).filter(n=>!n.isDirectory()&&n.name.endsWith(this.extension)).map(n=>n.name.slice(0,-this.extensionLength))||[];}catch{}let t=[...this.fileKeys||[]];for(let n of Object.keys(this.store))t.includes(n)||t.push(n);return t.sort(),t}};var lr={};function fr(e,t={}){let{level:n=void 0,filter:r=void 0,time:o=!0,pretty:i=!1}=t;e=path.resolve(process.cwd(),e),ze.mkdirSync(path.dirname(e),{recursive:!0});let a=ze.createWriteStream(e,{flags:"a"}),s=j(r),u=z(n);return c=>{if(!u(c.level)||!s(c.name))return;let p=o?`${new Date().toISOString()} `:"",l=c.name||"",f=lr[l||""];f==null&&(lr[l]=f);let d=[`[${l||"*"}]`,$e(c.messages,{pretty:i})];function g(...m){a.write(`${m.join("	")}
`);}switch(c.level){case O:g(`${p}I|*  `,...d);break;case B:g(`${p}W|** `,...d);break;case $:g(`${p}E|***`,...d);break;default:g(`${p}D|   `,...d);break}}}function Ti(e){return typeof e!="string"?[]:e?.split(`
`).map(t=>{let n=t.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(n){let r=n[3]||n[2]||n[4];return r.endsWith(")")&&(r=r.slice(0,-1)),r}})?.filter(Pn)??[]}function dr(e){if(e.includes("/node_modules/"))return "";let t="file://";if(e.startsWith(t))return e.substr(t.length);let n=path.resolve(process.cwd());if(n&&e.startsWith(n))return e.substr(n.length+1);let r=process.env?.HOME?path.resolve(process.env?.HOME):"";return r&&e.startsWith(r)&&(e=`~/${e.substr(r.length+1)}`),e}function Li(e){let t=e.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);if(t){let n=t[3]||t[2]||t[4];return n.endsWith(")")&&(n=n.slice(0,-1)),n}return ""}function It(e=2,t=!0){let n=new Error("stack").stack||"",r=Ti(n)?.[e];return r&&t&&(r=dr(r)),r||""}function gr(){return new Error("stack").stack||""}function mr(e,t=!0){let n="",r=new Error("stack").stack||"";if(typeof r=="string"){let o=r.split(`
`).map(a=>a.trim()),i=o.findIndex(a=>e.some(s=>a.startsWith(s)));n=o[i+1],n&&(n=Li(n)),n&&t&&(n=dr(n));}return n}function vi(){try{return ae(process.env.ZEED_COLOR,Ai__default.default.isatty(process.stdout.fd))}catch{}return !1}var Mt,yr=[6,2,3,4,5,1];function Ui(e){let t=0;for(let n=0;n<e.length;n++)t=(t<<5)-t+e.charCodeAt(n),t|=0;return yr[Math.abs(t)%yr.length]}var hr={},Ct;function Je(...e){process.stdout.write(`${$e(e)}
`);}var be={BOLD:"\x1B[1m",UNBOLD:"\x1B[2m",RED:"\x1B[31m",GREEN:"\x1B[32m",BLUE:"\x1B[34m",PURPLE:"\x1B[35m",GRAY:"\x1B[37m",ORANGE:"\x1B[38;5;208m",UNCOLOR:"\x1B[0m"};var br="\x1B[0m";function xe(e,t){return `${t===8?be.ORANGE:`\x1B[3${t<8?t:`8;5;${t}`}m`}${e}${br}`}function xr(e,t,n=!0){return e.map(r=>{if(typeof r!="string")return r;let o=t,i=br;return n&&(o=`${be.BOLD}${o}`,i=`${i}${be.BOLD}`),`${o}${r}${i}`})}var Ei="loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";function wr(e={}){Mt==null&&(Mt=vi()),Ct==null&&(Ct=he());let{level:t=void 0,filter:n=void 0,colors:r=Mt,levelHelper:o=!0,nameBrackets:i=!0,padding:a=0,fill:s=0,stack:u=!0,time:c=!0}=e,p=j(n),l=z(t);return f=>{if(!l(f.level)||!p(f.name))return;let d=he(),g=f.name||"",m=hr[g||""];m==null&&(m={color:Ui(g)},hr[g]=m);let b=Lt(d-Ct),y,T=i?`[${g}]`:g;if(a>0&&(T=T.padStart(a," ")),s>0&&(T=T.padEnd(s," ")),r){let h=m.color;y=[`${xe(T,h)} | `],f.level===B?y.push(...xr(f.messages,be.ORANGE)):f.level===$?y.push(...xr(f.messages,be.RED)):y.push(...f.messages),c&&y.push(xe(`+${b}`,h));}else y=[T,...f.messages],c&&y.push(`+${b}`);if(f.messages?.[0]===Ei&&console.log(gr()),u){let h="";typeof u=="boolean"?(h=mr(["at Function.","at null.log (","at log ("],!0),h||(h=It(0,!0))):h=It(typeof u=="number"?u:3,!0),h&&y.push(xe(`(${h})`,7));}let v="|",D=".";switch(f.level){case O:o&&(y[0]=`I${v}${D}   ${y[0]}`),Je(...y);break;case B:o&&(y[0]=(r?xe(`W${v}${D}${D}  `,8):`W${v}${D}${D}  `)+y[0]),Je(...y);break;case $:o&&(y[0]=(r?xe(`E${v}${D}${D}${D} `,1):`E${v}${D}${D}${D} `)+y[0]),Je(...y);break;default:o&&(y[0]=`D${v}    ${y[0]}`),Je(...y);break}}}function Di(e,t){return Ye(n=>{let r=[wr({padding:32,nameBrackets:!1})],o=process.env.ZEED_LOG??process.env.LOG,i=ae(process.env.ZEED_TIME,!0),a=ae(process.env.ZEED_PRETTY,!1);o&&r.unshift(fr(Rt(o),{time:i,pretty:a})),n.setHandlers(r);})(e,t)}

exports.BinaryEncoder = an;
exports.CRYPTO_DEFAULT_ALG = lt;
exports.CRYPTO_DEFAULT_DERIVE_ALG = un;
exports.CRYPTO_DEFAULT_DERIVE_ITERATIONS = Gr;
exports.CRYPTO_DEFAULT_HASH_ALG = cn;
exports.Channel = Et;
exports.CryptoEncoder = qn;
exports.DAY_MS = bn;
exports.Day = A;
exports.DefaultLogger = k;
exports.Emitter = C;
exports.FileStorage = cr;
exports.JsonEncoder = ce;
exports.LocalChannel = Ge;
exports.LogLevelAlias = $t;
exports.LogLevelAll = W;
exports.LogLevelDebug = J;
exports.LogLevelError = $;
exports.LogLevelFatal = Te;
exports.LogLevelInfo = O;
exports.LogLevelOff = X;
exports.LogLevelWarn = B;
exports.Logger = Di;
exports.LoggerConsoleHandler = we;
exports.LoggerContext = Ot;
exports.LoggerFileHandler = fr;
exports.LoggerMemoryHandler = Fl;
exports.LoggerNodeHandler = wr;
exports.MemStorage = Xn;
exports.NoopEncoder = Wn;
exports.Progress = Y;
exports.PubSub = Dt;
exports.SerialQueue = Kn;
exports.Uint8ArrayToDataUri = Aa;
exports.Uint8ArrayToHexDump = qt;
exports.Uint8ArrayToJson = Xe;
exports.Uint8ArrayToString = Ht;
exports.XRX = jn;
exports._decodeUtf8Polyfill = Pr;
exports._encodeUtf8Polyfill = Sr;
exports._useBase = eo;
exports.arrayAvg = Js;
exports.arrayBatches = Zs;
exports.arrayEmptyInPlace = js;
exports.arrayFilterInPlace = gt;
exports.arrayFlatten = se;
exports.arrayIntersection = Kr;
exports.arrayIsEqual = Qr;
exports.arrayMax = zs;
exports.arrayMin = Ws;
exports.arrayMinus = Jr;
exports.arrayRandomElement = Gs;
exports.arrayRemoveElement = dn;
exports.arraySetElement = Os;
exports.arrayShuffle = Vs;
exports.arrayShuffleForce = Hs;
exports.arrayShuffleInPlace = gn;
exports.arraySorted = Yr;
exports.arraySortedNumbers = Ns;
exports.arraySum = qs;
exports.arraySymmetricDifference = $s;
exports.arrayToggleInPlace = _s;
exports.arrayUnion = Zr;
exports.arrayUnique = dt;
exports.assert = Er;
exports.assertCondition = jt;
exports.avg = Ds;
exports.between = Es;
exports.bitfield = ys;
exports.blobToArrayBuffer = Hr;
exports.blobToDataUri = La;
exports.blobToUint8Array = hs;
exports.cloneJsonObject = qu;
exports.cloneObject = ue;
exports.cmp = pt;
exports.colorString = xe;
exports.colorStringList = xr;
exports.composeOrderby = ks;
exports.createArray = Ks;
exports.createBinaryStreamDecoder = ms;
exports.createBinaryStreamEncoder = gs;
exports.createLocalChannelPair = Vc;
exports.createPromise = vn;
exports.createPromiseProxy = Jn;
exports.csvParse = vo;
exports.csvParseToObjects = nc;
exports.csvStringify = tc;
exports.dataUriToBlob = Ta;
exports.dataUriToMimeType = wa;
exports.dataUriToUint8Array = ba;
exports.dateStringToDays = za;
exports.day = Ga;
exports.dayDay = io;
exports.dayDiff = Fa;
exports.dayFromAny = Ea;
exports.dayFromDate = _e;
exports.dayFromDateGMT = Sa;
exports.dayFromParts = wt;
exports.dayFromString = An;
exports.dayFromTimestamp = so;
exports.dayFromToday = Ln;
exports.dayIterator = Ia;
exports.dayMonth = wn;
exports.dayMonthStart = Pa;
exports.dayOffset = Oe;
exports.dayRange = ka;
exports.dayToDate = Tn;
exports.dayToDateGMT = Da;
exports.dayToParts = Ua;
exports.dayToString = ao;
exports.dayToTimestamp = xt;
exports.dayYear = bt;
exports.dayYearStart = Ra;
exports.debounce = El;
exports.decimal = uo;
exports.decimalCentsPart = Za;
exports.decimalFromCents = qa;
exports.decimalToCents = Ja;
exports.decodeBase16 = ea;
exports.decodeBase32 = mn;
exports.decodeBase58 = na;
exports.decodeBase62 = yn;
exports.decodeJson = ds;
exports.decrypt = pn;
exports.deepEqual = co;
exports.deepMerge = Ne;
exports.deepStripUndefinedInPlace = lo;
exports.deriveKeyPbkdf2 = Ts;
exports.detect = Vl;
exports.diffObjects = fo;
exports.digest = ws;
exports.duration = Dc;
exports.empty = Wu;
exports.encodeBase16 = Xs;
exports.encodeBase32 = mt;
exports.encodeBase58 = ta;
exports.encodeBase62 = yt;
exports.encodeJson = ps;
exports.encodeQuery = On;
exports.encrypt = fn;
exports.endSortWeight = $n;
exports.ensureFolder = df;
exports.ensureKey = Vu;
exports.ensureKeyAsync = Hu;
exports.equalBinary = Wt;
exports.escapeHTML = Rn;
exports.escapeRegExp = Mn;
exports.estimateSizeForBase = ra;
exports.exists = kt;
exports.fatal = Ur;
exports.fetchBasic = Yn;
exports.fetchJson = Bl;
exports.fetchOptionsBasicAuth = Ho;
exports.fetchOptionsFormURLEncoded = Ol;
exports.fetchOptionsJson = _l;
exports.fetchText = $l;
exports.files = vf;
exports.filesAsync = Ff;
exports.fixBrokenUth8String = ya;
exports.forEachDay = Va;
exports.forTimes = Ku;
exports.formatMessages = oo;
exports.formatMilliseconds = Lt;
exports.fromBase64 = ve;
exports.fromBase64String = Zi;
exports.fromCamelCase = sa;
exports.fromHex = zt;
exports.getEnvVariableRelaxed = af;
exports.getFingerprint = Af;
exports.getFingerprintAsync = Rf;
exports.getGlobal = Nl;
exports.getGlobalContext = Q;
exports.getGlobalEmitter = Ac;
exports.getGlobalLogger = Ye;
exports.getGlobalLoggerIfExists = _t;
exports.getNamespaceFilterString = Lr;
exports.getNavigator = Go;
exports.getPerformanceTimestamp = Nn;
exports.getSecureRandom = zr;
exports.getSecureRandomIfPossible = R;
exports.getSourceLocation = It;
exports.getSourceLocationByPrecedingPattern = mr;
exports.getStack = gr;
exports.getStackLlocationList = Ti;
exports.getStat = nr;
exports.getStatAsync = ir;
exports.getTimestamp = he;
exports.getWebCrypto = nf;
exports.getWindow = Qn;
exports.globToRegExp = qe;
exports.immediate = Ba;
exports.isArray = G;
exports.isBoolean = Sn;
exports.isBrowser = zo;
exports.isEven = Cn;
exports.isHalf = me;
exports.isHiddenPath = We;
exports.isInteger = Qa;
exports.isLocalHost = Sl;
exports.isNotNull = Pn;
exports.isNull = tu;
exports.isNullOrUndefined = eu;
exports.isNumber = Dn;
exports.isObject = H;
exports.isPrime = Ps;
exports.isPrimeRX = Ss;
exports.isPrimitive = Tt;
exports.isPromise = M;
exports.isRecord = je;
exports.isRecordPlain = Ya;
exports.isSafeInteger = Xa;
exports.isString = En;
exports.isTimeout = Oa;
exports.isUint8Array = nu;
exports.isValue = ru;
exports.joinToUint8Array = qi;
exports.jsonStringify = Gi;
exports.jsonStringifySafe = I;
exports.jsonStringifySorted = Hi;
exports.jsonToUint8Array = Qe;
exports.last = zu;
exports.lazyListener = vc;
exports.linkifyPlainText = Ou;
exports.listDistinctUnion = pu;
exports.listGroupBy = fu;
exports.listOfKey = du;
exports.listQuery = lu;
exports.loggerStackTraceDebug = Ei;
exports.memoize = Ju;
exports.memoizeAsync = Zu;
exports.moveSortWeight = ku;
exports.noop = ql;
exports.objectIsEmpty = xu;
exports.objectMap = yu;
exports.objectMergeDisposable = hu;
exports.parseArgs = Kl;
exports.parseBasicAuth = Vo;
exports.parseDate = Ec;
exports.parseLogLevel = Ze;
exports.parseOrderby = qr;
exports.parseQuery = _u;
exports.pbcopy = Ql;
exports.promisify = V;
exports.qid = Oc;
exports.randomBoolean = As;
exports.randomFloat = Us;
exports.randomInt = vs;
exports.randomUint8Array = ie;
exports.readText = mf;
exports.regExpEscape = Qu;
exports.regExpString = Lo;
exports.removeFolder = gf;
exports.renderMessages = $e;
exports.roundDown = Au;
exports.roundHalfAwayFromZero = Eu;
exports.roundHalfDown = Du;
exports.roundHalfEven = Su;
exports.roundHalfOdd = Uu;
exports.roundHalfTowardsZero = Pu;
exports.roundHalfUp = vu;
exports.roundUp = Lu;
exports.seededRandom = Rs;
exports.setUuidDefaultEncoding = Bc;
exports.setupEnv = uf;
exports.setupWebCrypto = tf;
exports.size = Gu;
exports.sleep = Ca;
exports.sortedItems = ho;
exports.sortedOrderby = Is;
exports.startSortWeight = Bn;
exports.stringToBoolean = ca;
exports.stringToFloat = fa;
exports.stringToInteger = la;
exports.stringToPath = Yo;
exports.stringToUInt8Array = Vt;
exports.suid = Ic;
exports.suidBytes = Hn;
exports.suidBytesDate = $o;
exports.suidDate = Mc;
exports.sum = Wr;
exports.throttle = Ul;
exports.timeout = $a;
exports.toBase64 = le;
exports.toBase64Url = Ji;
exports.toBool = ma;
exports.toCamelCase = hn;
exports.toCapitalize = to;
exports.toCapitalizeWords = ia;
exports.toFloat = pa;
exports.toHex = Gt;
exports.toHumanReadableFilePath = pf;
exports.toHumanReadableUrl = bo;
exports.toInt = da;
exports.toPath = Rt;
exports.toString = ga;
exports.toUint8Array = E;
exports.toValidFilename = In;
exports.today = Ha;
exports.tryTimeout = Un;
exports.uname = _;
exports.unescapeHTML = uu;
exports.useAsyncMutex = yc;
exports.useBase = q;
exports.useDefer = cc;
exports.useDispose = ye;
exports.useDisposer = uc;
exports.useEventListener = pc;
exports.useExitHandler = Hl;
exports.useInterval = fc;
exports.useLevelFilter = z;
exports.useMessageHub = Qc;
exports.useMutex = mc;
exports.useNamespaceFilter = j;
exports.usePool = hl;
exports.usePubSub = ol;
exports.useRPC = sl;
exports.useSorted = Cu;
exports.useTimeout = lc;
exports.uuid = K;
exports.uuid32bit = Cc;
exports.uuidB32 = Po;
exports.uuidB62 = Eo;
exports.uuidBytes = vt;
exports.uuidDecode = zn;
exports.uuidDecodeB32 = Fo;
exports.uuidDecodeB62 = So;
exports.uuidDecodeV4 = Co;
exports.uuidEncode = Oo;
exports.uuidEncodeB32 = Ro;
exports.uuidEncodeB62 = Do;
exports.uuidEncodeV4 = Mo;
exports.uuidIsValid = $c;
exports.uuidv4 = Io;
exports.valueToBoolean = ae;
exports.valueToFloat = ro;
exports.valueToInteger = no;
exports.valueToPath = Qo;
exports.valueToString = ht;
exports.waitOn = _a;
exports.walkSync = rr;
exports.walkSyncAsync = sr;
exports.writeText = yf;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.node.cjs.map